; *****************************************************
; *                                                   *
; * Cyber Crunch v1.1 - by Laze 'Cybernator' Ristoski *
; *                C64 Decrunch routine               *
; *                                                   *
; *****************************************************
; Source written in ACME crossassembler

                !to "decrunch.prg"
                *= $0200

get             = $02	; 2 bytes
put             = $04	; 2 bytes
offset          = $06	; 2 bytes
len             = $08	; 1 byte
cur             = $09	; 1 byte

                sta get
                stx get+1

                ldy #0
                sty cur
                lda (get),y
                sta put
                iny
                lda (get),y
                sta put+1

                clc
                lda #2
                adc get
                sta get
                bcc *+4
                inc get+1

mainloop        jsr getbit      ; Literal or crunched data?
                php
                lda #1          ; Get length (Elias Gamma)
getnextbit      jsr getbit
                bcs nomoregamma
                jsr getbit
                rol
                bpl getnextbit

nomoregamma     plp
                bcs crunched

                sta len
                ldy #0
nextliteral     lda (get),y
                sta (put),y
                iny
                cpy len
                bne nextliteral

                clc
                lda len
                adc get
                sta get
                bcc *+5
                inc get+1
                clc
                lda len
                adc put
                sta put
                bcc *+4
                inc put+1
                jmp mainloop

crunched        adc #0          ; Carry is set
                beq eof
                sta len

                lda #0
                sta offset
                sta offset+1

                jsr getbit      ; A=0
                rol
                jsr getbit
                rol
                tax

                ldy table,x
getoffset       jsr getbit
                rol offset
                rol offset+1
                dey
                bne getoffset

                lda displacement,x
		beq nodisp
                clc
                adc offset
                sta offset
                bcc *+4
                inc offset+1

nodisp          sec
                lda put
                sbc offset
                sta offset
                lda put+1
                sbc offset+1
                sta offset+1
                sec
                lda offset
                sbc #2
                sta offset
                bcs *+4
                dec offset+1

nextcrunch      lda (offset),y  ; Y=0
                sta (put),y
                iny
                cpy len
                bne nextcrunch

                clc
                lda len
                adc put
                sta put
                bcc *+4
                inc put+1
                jmp mainloop

getbit          asl cur
                beq *+3
                rts
                pha
                tya
                pha
                ldy #0
                lda (get),y
                inc get
                bne *+4
                inc get+1
                sec
                rol
                sta cur
                pla
                tay
                pla
eof             rts

table           !raw 2, 4, 6, 10
displacement    !raw 0, 4, 20, 84

















